Console = Class.Create(Object, function(instance, isDebugEnabled)

--  Initialization
	instance._ChatWindow = nil
	instance._IsDebugEnabled = isDebugEnabled or false

end)

function Console:Initialize()
	self._ChatWindow = CHAT_SYSTEM["containers"][1]["currentBuffer"]
end

function Console:EnableDebug(enable)
	self._IsDebugEnabled = enable or true
end

function Console:DisableDebug()
	self._IsDebugEnabled = false
end

function Console:IsDebugEnabled()
	return self._IsDebugEnabled
end

function Console:WriteDebug(message)

	if (message == nil) then
		return
	end

	if self._IsDebugEnabled then
		d(message)
	end

end

function Console:WriteLine(message)

	if (message == nil) then
		return
	end

	if (type(message) == "string") then
		self._ChatWindow:AddMessage(message)
	end

	if (message:IsOf(Message)) then
		self._ChatWindow:AddMessage(message:ToString())
	end
end

