Class = {}

function Class.Create(base, New)

--	Create a new class instance
	local __New = {}

	if not New and type(base) == 'function' then

		New = base
		base = nil

	elseif type(base) == 'table' then

--		The new class is a shallow copy of the base class

		for __Index, __Value in pairs(base) do
			__New[__Index] = __Value
		end

		__New._base = base

	end

--	The class will be the metatable for all its objects, and they will look up their methods in it.

	__New.__index = __New

--	Expose a constructor which can be called by <classname>(<args>)

	local __MetaTable = {}

	__MetaTable.__call =

		function(classMetaTable, ...)

			local __Instance = {}
			setmetatable(__Instance, __New)

			if New then
				New(__Instance, ...)
			else

--				Make sure that any stuff from the base class is initialized!
				if base and base.New then
					base.New(__Instance, ...)
				end

			end

			return __Instance

		end

	__New.New = New
	__New.IsOf =

		function(self, classType)

			local __Table = getmetatable(self)

			while __Table do

				 if __Table == classType then
					return true
				 end

				 __Table = __Table._Base

			  end

			  return false

		end

	setmetatable(__New, __MetaTable)

	return __New

end